﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace BorderColor_CS
{
    class Draw_Border : Control
    {
        [DllImport("user32.dll")]
        static extern int ReleaseDC(IntPtr hwnd, IntPtr hDC);

        [DllImport("user32.dll")]
        static extern IntPtr GetWindowDC(IntPtr hwnd);

        private Color borderColor = Color.Black;
        private static int WM_NCPAINT = 0x0085;

        public void DrawBorder(ref Message message, int width, int height)
        {
            if (message.Msg == WM_NCPAINT)
            {
                Pen penBorder = new Pen(borderColor, 5);
                IntPtr hdc = GetWindowDC(message.HWnd);                
                using (Graphics g = Graphics.FromHdc(hdc))
                {
                    Rectangle rDraw = new Rectangle(0, 0, width, height);
                    g.DrawRectangle(penBorder, rDraw);
                }
                ReleaseDC(message.HWnd, hdc);                
            }
            else 
            {
                base.WndProc(ref message);
            }
        }
        
        public Color BorderColor
        {
            get { return borderColor; }
            set { borderColor = value; }
        }
    }
}
